#DEFINE PAGE1
#include "p/redef.z80"
#define SHOWDEFS
#include "p/defs.z80"
.org $4000
.echo "Itemp4: "
.echo itemp4
.echo "\n"
#DEFINE APPNAME "SST     "
#DEFINE APPPAGES 1
#include "p/apphead.z80"
 jp ProgramStart
#include "p/offcalls.z80"
#include "p/IM2.z80"
 
.db "Loading...",0
ProgramStart:
 di
;=========================
;Put in routines to create and load the save files
;in this area, and have pointers set up to them.
;Because after this, the OS becomes unavailable.
 bcall(_ClrLCDFull)
 in a,(2)
 bit 7,a  ;checking hardware type
 jp z,SaveTheChuFoundation
 ld a,1
 out ($20),a  ;speeding up this process.
;=========================
 in a,(6)
 ld hl,basepage
 ld b,5
 ld (hl),a
 dec a
 inc hl
 djnz $-3
 ld (storeIY),IY    ;save the location for IY
 ld IY,myflag       ;overwrite IY with the location for my own flags.
 di                 ;make sure that interrupts are disabled before this
 ld a,$41
 ld i,a
 im 2               ;setup interrupt routine
 ld (iy+00),$00     ;initialize flags.
 ld (iy+01),$00
 call IOSaveLoad    ;rearrange RAM (workspace)
 ld hl,$425A        ;refers to "IntEmpty"
 ld (slot1),hl
 ld (slot2),hl
 ld (slot3),hl
 ld hl,$8000        ;initialize workspace. See next comment
 ld de,$8001
 ld bc,$0DFF
 ld (hl),$00
 ldir               ;clearing off to the far side of the buffer. 
;====================================
 ld a,%00001000  ;Acknowledge and disable
 out (3),a
 ld a,%00001010  ;Set 1st timer active
 out (3),a
 ld a,%00000110  ;Slowest frequency, ~110hz
 out (4),a
 ld a,2
 out (5),a       ;RAM PAGE $02 ($82) swapped in
 ld (stack),SP   ;save stack pointer to newly allocated space.
 ld SP,plotsscreen+76  ;new location for the stack
 jp EngineStart

IOMemAddress:
.dw $843F-6
.dw 57+6
.dw $84BF
.dw 73
.dw $8588
.dw 356
.dw $89EC
.dw 78
.dw $8C4D
.dw $8F00-$8C4D

IOSaveLoad:
 ld ix,IOMemAddress
 ld hl,appbackupscreen+(767-(564-6))  ;reading address
 ld a,4
 call IOSaveLoad1
 ld hl,plotsscreen+(767-691)
 ld a,1
IOSaveLoad1:
 ld e,(ix+0)  ;write to address
 ld d,(ix+1)
 ld bc,4
 add ix,bc
 ld c,(ix-2)
 ld b,(ix-1)
 bit 0,(iy+0)  ;if not zero
 jr nz,$+8     ;Jump to WRITE out to memory locations
 ex de,hl
 ldir
 ex de,hl
 jr $+4
 ldir
 dec a
 jr nz,IOSaveLoad1
 ret
;---------------------------------------------------------------------------
SaveTheCollection:
 call PutStringThingie
 ld hl,ErrorCollect
 call PutStringThingie
 bcall(_getKey)
 bjump(_jforcecmdnochar)
SaveTheChuFoundation:
 bcall(_ClrLCDFull)
 ld hl,VersionError
 jr SaveTheCollection

PutStringThingie:
 ld a,(hl)
 inc hl
 or a
 ret z
 push hl
  bcall(_PutC)
 pop hl
 jr PutStringThingie

VersionError:
.db "ERR:Version     "
.db "                "
.db "You need to have"
.db " a TI-83+SE or  "
.db " TI-84+(SE) to  "
.db " run this game  ",0

ErrorCollect:
.db "Press any key to"
.db "           exit.",0

;---------------------------------------------------------------------------
exitGame:
 di                          ;unload setup, ensure interrupts are disabled.
 ld sp,(stack)               ;
 xor a
 out (5),a                   ;set RAM page back to where it belongs.
 set 0,(iy+0)                ;Tell next routine that memory is to be restored
 call IOSaveLoad             ;restores memory structures for TI-OS
 ld iy,(storeiy)
 im 1
 bcall($5011)                ;restores first 1087 bytes in RAM
 bcall(_DelRes)              ;invalidates statistic variables.
 bcall($4C36)    ;reloadappentryvecs. Name is too long for TASM to swallow.
 bjump(_jforcecmdnochar)    ;Exit application.
 
#include "p/engine.z80"       ;RAWR!
#include "p/extradat.z80"     ;RRAWWR!!!
#include "p/classic.z80"      ;GRAVY!!!!!


.echo "Rickroll based on E:SoR engine, size remaining: "
.echo $7000-$
.echo "\n"

#include "p/txmapdat.z80"     ;AND BISCUITS!!!!!!!!!



.end